#include "../../../lib/std.mi"

#define ROTATION_LAYER_VAR secondvar
#include "../../../lib/rotationlayer.m"

#define ROTATION_LAYER_VAR_B minvar
#include "../../../lib/rotationlayer2.m"

#define ROTATION_LAYER_VAR_C hourvar
#include "../../../lib/rotationlayer3.m"

function int getCurrentHour();
function int getCurrentMin();
function int getCurrentSec();
function renderClock();

Global Group CGroup;
Global Layer HourL, MinL, SecL;
Global Timer UpDateClockTimer;

int getCurrentHour() {
  int hour = (getTimeOfDay()/3600000);
  return hour;
}

int getCurrentMin() {
  int min = ((getTimeOfDay()/60000) - (getCurrentHour()*60));
  return min;
}

int getCurrentSec() {
  int sec = (((getTimeOfDay()/1000) - (getCurrentMin()*60)) - (getCurrentHour()*3600));
  return sec;
}

System.onScriptLoaded() {
  CGroup = getScriptGroup();
  SecL = CGroup.getObject("sec");
  _secondvarInit(CGroup, "sec");
  _minvarInit(CGroup, "min");
  _hourvarInit(CGroup, "hour");

  renderClock();

  UpDateClockTimer = new timer;
  UpDateClockTimer.setDelay(333);
  UpDateClockTimer.start();
  
}

UpDateClockTimer.onTimer() {
  renderClock();
}

renderClock() {
  _secondvarRotateDegree(360-(getCurrentSec() * 6));
  _minvarRotateDegree(360-(getCurrentMin() * 6));
  _hourvarRotateDegree(360-(getCurrentHour() * 30));
}