#include "../../../lib/std.mi"

Global Layout MN, MS;
Global Group VolPos, VPMask, SGroup, SMask, ScreenG, ClockG, ClockGS;
Global Layer l_vpbg, l_vpv, l_vpp, l_sbg, l_cap, mainlayer, svol, spos, tickercover2;
Global Button ToggleSee, VisSwitch, MuteB;
Global Boolean vorh, VISOR, Blocks, Muted;
Global Timer Startupl, aminRev;
Global Map sVolMap, sPosMap;
Global Timer UpateTimer;
Global AnimatedLayer AnimThingy;
Global Int OldVol;

System.onScriptLoaded() {
  MN = getContainer("main").getLayout("normal");
  MS = getContainer("main").getLayout("shade");
  ToggleSee = MN.getObject("colour.sets.toggle");

  VPMask = MN.getObject("group.vol.mask");
  VolPos = VPMask.getObject("group.volume");

  svol = MS.getObject("vol");
  spos = MS.getObject("pos");
  sVolMap = new map;
  sVolMap.loadmap("winshade.vol.map");
  sPosMap = new map;
  sPosMap.loadmap("winshade.pos.map");

  SMask = MN.getObject("group.setup.mask");
  SGroup = SMask.getObject("group.setup");
  ScreenG = MN.getObject("group.screen");
  l_cap = ScreenG.getObject("start.cap.screen");
  l_sbg = SGroup.getObject("layer.base.setup");

  l_vpbg = VolPos.getObject("layer.base.vol");
  l_vpv = VolPos.getObject("layer.volume");
  l_vpp = VolPos.getObject("layer.seek");

  mainlayer = MN.getObject("player.overlay");

  Startupl = new timer;
  Startupl.setDelay(2500);
  Startupl.start();

  vorh = 0;

  UpateTimer = new Timer;
  UpateTimer.setDelay(99);

  if(getStatus() != 1) {
    UpateTimer.stop();
  } else {
    UpateTimer.start();
  }

  System.onVolumeChanged(getVolume());

  ClockG = ScreenG.getObject("group.clock");
  ClockGS = ScreenG.getObject("group.clock.shaddow");
  VisSwitch = MN.getObject("vis.switcher");
  AnimThingy = ScreenG.getObject("anim.scree.b");
  tickercover2 = ScreenG.getObject("tickercover2");
  VISOR=false;
  Blocks=false;
  aminRev = new timer;
  aminRev.setDelay(66);
  tickercover2.hide();
  ClockG.hide();
  ClockGS.hide();

  MuteB = VolPos.getObject("mute");
}

VisSwitch.onLeftButtonUp(int x, int y) {
  if(Blocks) return;
  Blocks=true;
  if(!VISOR) {
    AnimThingy.setTargetA(255);
    AnimThingy.setTargetSpeed(1);
    AnimThingy.gotoTarget();
  } else {
    tickercover2.setTargetA(255);
    tickercover2.setTargetSpeed(1);
    tickercover2.gotoTarget();
  }
}

AnimThingy.onTargetReached() {
  if(!VISOR) {
    AnimThingy.setSpeed(100);
    AnimThingy.setStartFrame(1);
    AnimThingy.play();
  } else {
    Blocks=false;
    VISOR=false;
  }
}

AnimThingy.onFrame(Int framenum) {
  if(!VISOR) {
    if(framenum == AnimThingy.getEndFrame()) {
      AnimThingy.stop();
      tickercover2.show();
      ClockG.show();
      ClockGS.show();
      tickercover2.setTargetA(0);
      tickercover2.setTargetSpeed(1);
      tickercover2.gotoTarget();
    }
  }
}

tickercover2.onTargetReached() {
  if(!VISOR) {
    VISOR=true;
    Blocks=false;
  } else {
    ClockG.hide();
    ClockGS.hide();
    tickercover2.hide();
    aminRev.start();
  }
}

aminRev.onTimer() {
  if(AnimThingy.getCurFrame() != 0) {
    AnimThingy.gotoFrame(AnimThingy.getCurFrame()-1);
  } else {
    aminRev.stop();
    AnimThingy.setTargetA(0);
    AnimThingy.setTargetSpeed(1);
    AnimThingy.gotoTarget();
  }
}

ToggleSee.onLeftButtonUp(int x, int y) {
  if(vorh == 0) {
    l_vpbg.setTargetA(255);
    l_vpv.setTargetA(255);
    l_vpp.setTargetA(255);
    l_sbg.setTargetA(255);
    VolPos.setTargetX(28);
    SGroup.setTargetX(14);

    l_vpbg.setTargetSpeed(1);
    l_vpv.setTargetSpeed(1);
    l_vpp.setTargetSpeed(1);
    VolPos.setTargetSpeed(1);
    SGroup.setTargetSpeed(1);
    l_sbg.setTargetSpeed(1);

    l_vpbg.gotoTarget();
    l_vpv.gotoTarget();
    l_vpp.gotoTarget();
    VolPos.gotoTarget();
    SGroup.gotoTarget();
    l_sbg.gotoTarget();

    vorh = 1;
  } else {
    l_vpbg.setTargetA(0);
    l_vpv.setTargetA(0);
    l_vpp.setTargetA(0);
    l_sbg.setTargetA(0);
    VolPos.setTargetX(-100);
    SGroup.setTargetX(-140);

    l_vpbg.setTargetSpeed(1);
    l_vpv.setTargetSpeed(1);
    l_vpp.setTargetSpeed(1);
    VolPos.setTargetSpeed(1);
    SGroup.setTargetSpeed(1);
    l_sbg.setTargetSpeed(1);

    l_vpbg.gotoTarget();
    l_vpv.gotoTarget();
    l_vpp.gotoTarget();
    VolPos.gotoTarget();
    SGroup.gotoTarget();
    l_sbg.gotoTarget();

    vorh = 0;
  }
}

Startupl.onTimer() {
  l_cap.setTargetA(0);
  l_cap.setTargetSpeed(1);
  l_cap.gotoTarget();
  Startupl.stop();
}

mainlayer.onLeftButtonDblClk(int x, int y) {
  getContainer("main").switchToLayout("shade");
}

System.onVolumeChanged(int newvol) {
  svol.setRegionFromMap(sVolMap,newvol,1);
}

UpateTimer.onTimer() {
  System.onSeek(getPosition());
}

System.onSeek(int newpos) {
  if (newpos <= 0) return;
  int len = getPlayItemLength();
  int devby = len/255;
  spos.setRegionFromMap(sPosMap,newpos/devby,1);
}

System.onPlay() {
  spos.setRegionFromMap(sPosMap,0,1);
  UpateTimer.start();
}

System.onStop() {
  spos.setRegionFromMap(sPosMap,255,1);
  UpateTimer.stop();
}

MuteB.onLeftButtonUp(int x, int y) {
  if(Muted) {
    Muted = false;
    setVolume(OldVol);
  } else {
    Muted = true;
    OldVol = getVolume();
    setVolume(0);
  }
}