#include "../../../lib/std.mi"

Global Group MainG;
Global Layer VolL, SeekL;
Global Map MMap;
Global Timer UpateTimer;

System.onScriptLoaded() {
  MainG = getScriptGroup();
  VolL = MainG.getObject("layer.volume");
  SeekL = MainG.getObject("layer.seek");

  MMap = new map;
  MMap.loadMap("player.volume.map");
  UpateTimer = new Timer;
  UpateTimer.setDelay(99);

  if(getStatus() != 1) {
    UpateTimer.stop();
  } else {
    UpateTimer.start();
  }
  onVolumeChanged(getVolume());
}

System.onSeek(int newpos) {
  if (newpos <= 0) return;
  int len = getPlayItemLength();
  int devby = len/255;
  SeekL.setRegionFromMap(MMap,newpos/devby,1);
}

System.onPlay() {
  SeekL.setRegionFromMap(MMap,0,1);
  UpateTimer.start();
}

System.onStop() {
  SeekL.setRegionFromMap(MMap,255,1);
  UpateTimer.stop();
}

UpateTimer.onTimer() {
  System.onSeek(getPosition());
}

System.onVolumeChanged(int newvol) {
  VolL.setRegionFromMap(MMap,newvol,1);
}